#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    
    edges = []
    nodes = list(range(n))
    random.shuffle(nodes)

    for i in range(1, n):
        if random.randint(0, 1) == 0:
            edges.append((nodes[i-1], nodes[i]))
        else:
            edges.append((nodes[i], nodes[i-1]))
    
    random.shuffle(edges)
    print(n)
    for (u, v) in edges:
        print(u+1, v+1)
    
    
if __name__ == "__main__":
    main()
