#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default

def main():
    N = int(cmdlinearg("N"))
    rem = int(cmdlinearg("remove", 0))
    addc5 = bool(cmdlinearg("addc5", False))

    E = N * N - rem

    eds = []
    for i in range(N):
        for j in range(N, 2*N):
            eds.append((i + 1, j + 1))

    eds = list(random.sample(eds, E))

    if addc5: 
        eds.append((2*N, 2*N + 1))
        eds.append((2*N + 1, 2*N + 2))
        eds.append((2*N + 2, 2*N + 2))
        eds.append((2*N + 3, 2*N + 3))
        eds.append((2*N + 4, 2*N))
        print(2*N + 5, len(eds))
    else:
        print(2*N, len(eds))
    for a, b in eds:
        print(a, b)
    
if __name__ == "__main__":
    main()
