#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define trav(it,x) for(auto& it : x)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

template<typename T, typename S> ostream& operator<<(ostream& os, const pair<T, S> &v) { return os << v.first << " " << v.second; }
template<typename T, typename S> istream& operator>>(istream& is, const pair<T, S> &v) { return is >> v.first >> v.second; }
template<typename T> ostream& operator<<(ostream& os, const vector<T> &v) { rep(i,0,sz(v)) { if (i) os << " " << v[i]; else os << v[i]; } os << endl; return os; }
template<typename T> istream& operator>>(istream& is, vector<T> &v) { trav(it, v) is >> it; return is; }
template<typename T> using v = vector<T>; template<typename T> using vv = v<v<T>>; template<typename T> using vvv = v<v<v<T>>>;
template<typename T> std::vector<T> make(T init, std::size_t size) { return std::vector<T>(size, init); }
template<typename T, typename... Args> auto make(T init, std::size_t first, Args... sizes) { auto inner = make<T>(init, sizes...); return std::vector<decltype(inner)>(first, inner); }
template<typename A, typename B> auto smax(A& a, const B& b) { if (b > a) a = b; }
template<typename A, typename B> auto smin(A& a, const B& b) { if (b < a) a = b;}
bool within(int r, int c, int R, int C) { return 0 <= r && r < R && 0 <= c && c < C; }


vector<vi> G;

vi bfs(int source) {
    vi dist = make(sz(G) + 1, G.size());
    dist[source] = 0;
    queue<int> Q;
    Q.push(source);
    while (!Q.empty()){
        int a = Q.front();
        Q.pop();
        trav(y, G[a]){
            if (dist[y] == sz(G) + 1){
                dist[y] = 1 + dist[a];
                Q.push(y);
            }
        }
    }
    return dist;
}

bool generate(int N, int E, int girth) {
    G = make(0, N, 0);
    vector<pii> edges;
    int tries = 0;
    rep(i,0,E) {
        int from = rand() % N;
        vi dist = bfs(from);
        vi cand;
        rep(j,0,N) {
            if (dist[j] + 1 >= girth) cand.push_back(j);
        }
        if (cand.empty()) {
            --i;
            if (++tries >= 1000) return false;
            continue;
        }
        tries = 0;
        int w = cand[rand() % cand.size()];
        G[from].push_back(w);
        G[w].push_back(from);
        edges.emplace_back(from+1, w+1);
    }
    for (auto [a, b] : edges) {
        cout << a << " " << b << endl;
    }
    return true;
}

int main(int argc, char** argv) {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    int N = -1, E = -1, G = -1;

    for (int i = 1; i < argc; i++) {
        string s = argv[i];
        size_t ind = s.find('=');
        if (ind == string::npos) continue;
        auto before = s.substr(0, ind), after = s.substr(ind + 1);
        if (before == "N") {
            N = stoi(after);
        }
        if (before == "E") {
            E = stoi(after);
        }
        if (before == "G") {
            G = stoi(after);
        }
    }
    srand(atoi(argv[argc-1]));
    assert(N >= 0 && E >= 0 && G >= 0);

    cout << N << " " << E << endl;
    while (!generate(N, E, G));
}

