#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define trav(it,x) for(auto& it : x)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

template<typename T, typename S> ostream& operator<<(ostream& os, const pair<T, S> &v) { return os << v.first << " " << v.second; }
template<typename T, typename S> istream& operator>>(istream& is, const pair<T, S> &v) { return is >> v.first >> v.second; }
template<typename T> ostream& operator<<(ostream& os, const vector<T> &v) { rep(i,0,sz(v)) { if (i) os << " " << v[i]; else os << v[i]; } os << endl; return os; }
template<typename T> istream& operator>>(istream& is, vector<T> &v) { trav(it, v) is >> it; return is; }
template<typename T> using v = vector<T>; template<typename T> using vv = v<v<T>>; template<typename T> using vvv = v<v<v<T>>>;
template<typename T> std::vector<T> make(T init, std::size_t size) { return std::vector<T>(size, init); }
template<typename T, typename... Args> auto make(T init, std::size_t first, Args... sizes) { auto inner = make<T>(init, sizes...); return std::vector<decltype(inner)>(first, inner); }
template<typename A, typename B> auto smax(A& a, const B& b) { if (b > a) a = b; }
template<typename A, typename B> auto smin(A& a, const B& b) { if (b < a) a = b;}
bool within(int r, int c, int R, int C) { return 0 <= r && r < R && 0 <= c && c < C; }


vector<vi> G;

vi bfs(int source) {
    vi dist = make(sz(G) + 1, G.size());
    dist[source] = 0;
    queue<int> Q;
    Q.push(source);
    while (!Q.empty()){
        int a = Q.front();
        Q.pop();
        trav(y, G[a]){
            if (dist[y] == sz(G) + 1){
                dist[y] = 1 + dist[a];
                Q.push(y);
            }
        }
    }
    return dist;
}

bool generate(int N, int K, double c) {
    int g = int(c * log(N) / log(K - 1));
    assert(g >= 3);
    cerr << "target girth: " << g << endl;

    G = make(0, N, 0);
    rep(i,0,N-1) {
        G[i].push_back(i+1);
        G[i+1].push_back(i);
    }
    G[0].push_back(N-1);
    G[N-1].push_back(0);

    while (true) {
        int mindeg = N;
        for (auto& nei : G) {
            smin(mindeg, sz(nei));
        }
        if (mindeg >= K) break;

        vi cand;
        rep(i,0,N) if (sz(G[i]) == mindeg) cand.push_back(i);
        random_shuffle(all(cand));
        trav(from, cand) {
            vi dist = bfs(from);
            trav(to, cand) {
                if (dist[to] + 1 >= g) {
                    G[from].push_back(to);
                    G[to].push_back(from);
                    goto nexted;
                }
            }
        }
        return false;
nexted:;
    }
    int eds = 0;
    trav(it, G) eds += sz(it);
    eds /= 2;
    
    cout << N << " " << eds << endl;
    rep(a,0,N) 
        trav(b, G[a]) 
            if (a < b) cout << a+1 << " " << b+1 << endl;
    return true;
}

int main(int argc, char** argv) {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    int N = -1, K = -1;
    double c = -1;

    for (int i = 1; i < argc; i++) {
        string s = argv[i];
        size_t ind = s.find('=');
        if (ind == string::npos) continue;
        auto before = s.substr(0, ind), after = s.substr(ind + 1);
        if (before == "N") {
            N = stoi(after);
        }
        if (before == "K") {
            K = stoi(after);
        }
        if (before == "c") {
            c = stod(after);
        }
    }
    srand(atoi(argv[argc-1]));
    assert(N >= 0 && K >= 0 && c >= 0);

    while (!generate(N, K, c));
}

