#!/usr/bin/python3

import sys
import random

default = {
    "s": 10**6,
    "mode": "random",
    "copies": 1,
    "errors": 0,
    "letters": 26,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    s = int(cmdlinearg("s"))
    mode = cmdlinearg("mode")
    errors = int(cmdlinearg("errors"))
    letters = int(cmdlinearg("letters"))
    copies = int(cmdlinearg("copies"))
    n = 2
    s -= errors

    alphabet = random.sample(list("abcdefghijklmnopqrstuvwxyz"), letters)
    sum_l = s // (2 * copies)

    length1 = random.randrange(1, sum_l)
    length2 = sum_l - length1

    grid = []

    if mode == "random":
        a = "".join([alphabet[random.randrange(0, letters)] for _ in range(length1)])
        b = "".join([alphabet[random.randrange(0, letters)] for _ in range(length2)])
        row1 = "".join([a+b]*copies)
        row2 = "".join([b+a]*copies)
        grid.append(["*", row1])
        grid.append([row2, "*"])
    elif mode == "thuemorse":
        tm = ['a']
        tm2 = ['b']
        while 2*len(tm) < sum_l:
            old_size = len(tm)
            for i in range(old_size):
                ch = 'a'
                ch2 = 'b'
                if tm[i] == 'a':
                    ch = 'b'
                    ch2 = 'a'
                tm2.append(ch2)
                tm.append(ch)
        tm = "".join(tm)
        tm2 = "".join(tm2)
        rest = "".join(['a'] * (sum_l - len(tm)))
        grid.append(["*", tm+rest])
        grid.append([rest+tm2, "*"])
    elif mode == "same":
        tot = [alphabet[0] for _ in range(s // 2)]
        for _ in range(copies):
            i = random.randrange(0, s // 2)
            r = random.randrange(1, letters)
            tot[i] = alphabet[r]
        x = random.randrange(1, s // 2)
        a = "".join(tot[:x])
        b = "".join(tot[x:])
        grid.append(["*", a+b])
        grid.append([b+a, "*"])
    elif mode == "valid":
        c = "".join([alphabet[random.randrange(0, letters)] for _ in range(sum_l)])
        tot = list("".join([c] * copies))
        x = random.randrange(1, len(tot))

        i = random.randrange(1, len(tot))
        (tot[i-1], tot[i]) = (tot[i], tot[i-1])

        a = "".join(tot[:x])
        b = "".join(tot[x:])
        grid.append(["*", a+b])
        grid.append([b+a, "*"])
    elif mode == "empty":
        s = "".join([alphabet[random.randrange(0, letters)] for _ in range(s // 2)])
        grid.append(['*', s])
        grid.append([s, '*'])
    
    for _ in range(errors):
        r = (0, 1)
        if random.randint(0, 1) == 1:
            r = (1, 0)
        for i in range(n):
            for j in range(n):
                if (i, j) == r:
                    new_r = []
                    r2 = random.randrange(0, len(grid[i][j]))
                    for k in range(len(grid[i][j])):
                        if k == r2:
                            new_r.append(alphabet[random.randrange(0, letters)])
                        else:
                            new_r.append(grid[i][j][k])
                    grid[i][j] = "".join(new_r)
    
    print(n)
    for i in range(n):
        print(*grid[i])
        
    
    
    
    
if __name__ == "__main__":
    main()
