#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "k": 5,
    "mode": "random",
    "lo": 0.5,
    "hi": 1.0,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    k = int(cmdlinearg("k"))
    mode = cmdlinearg("mode")
    lo = float(cmdlinearg("lo"))
    hi = float(cmdlinearg("hi"))
    
    P = []

    if mode == "random":
        for _ in range(n):
            P.append(round(random.random()*(hi-lo)+lo, 6))
    elif mode == "two":
        for _ in range(n):
            if random.randint(0, 1) == 1:
                P.append(round(lo, 6))
            else:
                P.append(round(hi, 6))
    elif mode == "low":
        dx = (hi-lo) / n
        for _ in range(n):
            P.append(round(random.random()*(hi-lo)+lo, 6))
            hi -= dx
        random.shuffle(P)
    elif mode == "twogood":
        P.append(0.9)
        P.append(0.9)
        P += [0.5] * (n-2)
        random.shuffle(P)
    
    print(n, k)
    print(*P)
    
    
if __name__ == "__main__":
    main()
