#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default

def main():
    random.seed(int(sys.argv[-1]))
    N = int(cmdlinearg("N"))
    peaks = int(cmdlinearg("peaks"))
    H = [318 * 10**9 - 1 for _ in range(N)]
    s = list(sorted(random.sample(range(N), peaks)))
    for p in s: H[p] += 1

    w = random.randint(0, peaks - 2)
    H[w] += 1
    H[w + 1] += 1

    print(len(H))
    print(*H)
    
if __name__ == "__main__":
    main()
