#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default


def main():
    random.seed(int(sys.argv[-1]))
    N = int(cmdlinearg("N"))
    peaks = int(cmdlinearg("peaks"))
    peaki = list(sorted(random.sample(range(N - peaks - 2), peaks)))
    for i in range(peaks): peaki[i] += i + 1
    for p in peaki: assert 0 < p < N - 1

    H = [random.randint(0, 318 * 10**9) for _ in range(N)]

    def decreasing(L, R):
        num = R - L - 1
        H[L+1:R] = list(sorted(random.choices(range(H[R], H[L]+1), k=num)))

    def increasing(L, R):
        num = R - L - 1
        H[L+1:R] = list(sorted(random.choices(range(H[L], H[R]+1), k=num)))

    H[0] = random.randint(0, H[peaki[0]])
    increasing(0, peaki[0])
    for i in range(peaks - 1):
        L = peaki[i]
        R = peaki[i + 1]
        mid = random.randint(L + 1, R - 1)
        H[mid] = random.randint(0, min(H[L], H[R]))
        decreasing(L, mid)
        increasing(mid, R)
    
    H[-1] = random.randint(0, H[peaki[-1]])
    decreasing(peaki[-1], N-1)

    print(N)
    print(*H)
    
if __name__ == "__main__":
    main()
