#!/bin/bash
USE_SCORING=0
. ../../..//testdata_tools/gen.sh

# ulimit -s unlimited

use_solution js.py

compile gen_random.py
compile gen_fixed_peaks.py
compile gen_same.py
compile gen_stair.py
compile gen_almost_same.py
compile gen_almost_same_unique.py
compile gen_plateu.py
compile gen_asc.py
compile gen_desc.py

MAXN=200000

sample 1
sample 2

tc small-1 gen_random N=7 maxh=10
tc small-2 gen_random N=7 maxh=10
tc small-3 gen_random N=7 maxh=10

tc all_same_0 gen_same N=$MAXN h=0
tc all_same_max gen_same N=$MAXN h=318000000000

tc plateu-even gen_plateu N=$MAXN
tc plateu-odd gen_plateu N=199999

tc asc gen_asc N=$MAXN
tc desc gen_desc N=$MAXN

tc almost_same-1 gen_almost_same N=$MAXN peaks=1
tc almost_same-2 gen_almost_same N=$MAXN peaks=1
tc almost_same-3 gen_almost_same N=$MAXN peaks=1
tc almost_same-4 gen_almost_same N=$MAXN peaks=500
tc almost_same-5 gen_almost_same N=$MAXN peaks=10000

tc almost_same_single_sol-1 gen_almost_same_unique N=$MAXN peaks=2
tc almost_same_single_sol-2 gen_almost_same_unique N=$MAXN peaks=2
tc almost_same_single_sol-3 gen_almost_same_unique N=$MAXN peaks=2
tc almost_same_single_sol-4 gen_almost_same_unique N=$MAXN peaks=500
tc almost_same_single_sol-5 gen_almost_same_unique N=$MAXN peaks=500
tc almost_same_single_sol_6 gen_almost_same_unique N=$MAXN peaks=10000
tc almost_same_single_sol_7 gen_almost_same_unique N=$MAXN peaks=10000

tc stair gen_stair N=$MAXN

tc all_peaks-1 gen_fixed_peaks N=$MAXN peaks=99999
tc all_peaks-2 gen_fixed_peaks N=$MAXN peaks=99999

tc single_peak-1 gen_fixed_peaks N=$MAXN peaks=1
tc single_peak-2 gen_fixed_peaks N=$MAXN peaks=1
tc single_peak-3 gen_fixed_peaks N=$MAXN peaks=1

tc random-1 gen_random N=$MAXN
tc random-2 gen_random N=$MAXN
tc random-3 gen_random N=$MAXN
tc random-4 gen_random N=$MAXN maxh=100
tc random-5 gen_random N=$MAXN maxh=100
tc random-6 gen_random N=$MAXN maxh=1000

tc few_peaks-1 gen_fixed_peaks N=$MAXN peaks=5
tc few_peaks-2 gen_fixed_peaks N=$MAXN peaks=10
tc few_peaks-3 gen_fixed_peaks N=$MAXN peaks=100
tc few_peaks-4 gen_fixed_peaks N=$MAXN peaks=1000
tc few_peaks-5 gen_fixed_peaks N=$MAXN peaks=10000
