#!/bin/bash
USE_SCORING=0
. ../../../testdata_tools/gen.sh

# ulimit -s unlimited

use_solution nils.cpp

compile gen.py
compile gen_bipartite.py

MAXN=300000

sample_manual 1
sample_manual 2


tc random-01 gen n=10 m=10
tc random-02 gen n=2 m=1
tc random-03 gen n=2 m=0
tc random-04 gen n=3 m=1
tc random-05 gen n=10 m=40
tc random-06 gen n=10 m=45
tc random-07 gen n=15 m=40
tc random-08 gen n=15 m=1
tc random-09 gen n=150 m=150
tc random-10 gen n=1500 m=1500
tc random-11 gen n=15000 m=15000
tc random-12 gen n=$MAXN m=0
tc random-13 gen n=$MAXN m=1
tc random-14 gen n=$MAXN m=100
tc random-15 gen n=$MAXN m=100000
tc random-16 gen n=$MAXN m=$MAXN
tc random-17 gen n=1000 m=$MAXN
tc random-18 gen n=1500 m=$MAXN
tc random-19 gen n=10000 m=$MAXN

tc stars-20 gen n=10 m=40 mode=stars
tc stars-21 gen n=100 m=198 mode=stars
tc stars-22 gen n=1000 m=$MAXN mode=stars
tc stars-23 gen n=3000 m=$MAXN mode=stars
tc stars-24 gen n=10000 m=$MAXN mode=stars
tc stars-25 gen n=40000 m=$MAXN mode=stars
tc stars-26 gen n=100000 m=$MAXN mode=stars
tc stars-27 gen n=$MAXN m=$MAXN mode=stars

tc bipartite-28 gen_bipartite n=1000 part=500
tc bipartite-29 gen_bipartite n=750 part=50
tc bipartite-30 gen_bipartite n=750 part=700
tc bipartite-31 gen_bipartite n=750 part=300 mode=leftstar
tc bipartite-32 gen_bipartite n=750 part=300 mode=rightstar
tc bipartite-33 gen_bipartite n=750 part=30 mode=leftstar
tc bipartite-34 gen_bipartite n=750 part=30 mode=rightstar
tc bipartite-35 gen_bipartite n=750 part=700 mode=leftstar
tc bipartite-36 gen_bipartite n=750 part=700 mode=rightstar
tc bipartite-37 gen_bipartite n=1500 part=750 mode=leftstar
tc bipartite-38 gen_bipartite n=1500 part=750 mode=rightstar

tc bipartite-39 gen_bipartite n=1000 part=500 complement=1
tc bipartite-40 gen_bipartite n=750 part=300 mode=rightstar complement=1
tc antigreedy-41 gen_bipartite n=1000 part=500 mode=antigreedy
tc antigreedy-42 gen_bipartite n=700 part=27 mode=antigreedy
tc antigreedy-43 gen_bipartite n=1000 part=497 mode=antigreedy complement=1

tc trianglestar-44 gen n=5 m=6 mode=trianglestar
tc trianglestar-45 gen n=199999 m=$MAXN mode=trianglestar
tc star12-46 gen n=$MAXN m=$MAXN mode=star12
tc star12-47 gen n=150000 m=$MAXN mode=star12
tc star12-48 gen n=60000 m=$MAXN mode=star12
tc star12-49 gen n=15000 m=$MAXN mode=star12
tc starpath-50 gen n=200000 m=$MAXN mode=starpath
tc starpath-51 gen n=200001 m=$MAXN mode=starpath
tc halfpath-52 gen n=$MAXN m=$MAXN mode=halfpath
tc halfpath-53 gen n=277777 m=$MAXN mode=halfpath

tc antigreedy-54 gen_bipartite n=1001 m=$MAXN part=500 mode=isolate
tc antigreedy-55 gen_bipartite n=1001 m=$MAXN part=371 mode=isolate
tc antigreedy-56 gen_bipartite n=2333 m=$MAXN part=1427 mode=isolate
tc antigreedy-57 gen_bipartite n=41337 m=$MAXN part=7 mode=isolate
tc antigreedy-59 gen_bipartite n=99999 m=$MAXN part=3 mode=isolate
tc antigreedy-60 gen_bipartite n=102311 m=$MAXN part=5 mode=isolate
tc antigreedy-61 gen_bipartite n=149999 m=$MAXN part=2 mode=isolate

tc clique-62 gen n=753 m=$MAXN mode=isolated_clique
